package com.cours.dao.factory;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.cours.dao.IAdresseDao;
import com.cours.dao.IPersonneDao;
import com.cours.dao.jpa.AdresseDao;
import com.cours.dao.jpa.PersonneDao;

public class DaoFactory extends AbstractDaoFactory {

	private static final Log log = LogFactory.getLog(DaoFactory.class);
	private static IPersonneDao personneDao = null;
	private static IAdresseDao adresseDao = null;
	private static String className = DaoFactory.class.getSimpleName();

	private DaoFactory() {
		personneDao = new PersonneDao();
		adresseDao = new AdresseDao();
	}

	/**
	 * Holder
	 */
	private static class MySingletonHolder {

		/**
		 * Instance unique non préinitialisée
		 */
		private final static DaoFactory instance = new DaoFactory();
	}

	/**
	 * Point d'accès pour l'instance unique du singleton
	 *
	 * @return
	 */
	public static DaoFactory getInstance() {
		if (DaoFactory.MySingletonHolder.instance == null) {
			log.debug("--> Nouvelle Instance de " + className);
		} else {
			log.debug("--> Re-Utilisation de l'instance " + className + " dejà existante ");
		}
		return DaoFactory.MySingletonHolder.instance;
	}

	@Override
	public IPersonneDao getPersonneDao() {
		return personneDao;
	}

	@Override
	public IAdresseDao getAdresseDao() {
		return adresseDao;
	}
}
